#ifndef __ANIME_H__
#define __ANIME_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define ANIME_MAX_PAT_CNT			18
#define ANIME_MAX_DAT_CNT			4
#define ANIME_MAX_STR_LEN			9

enum {
	ANIME_ACT_OP = 0x01,					// IyR[h擾
	ANIME_ACT_FUNC,							// @\s
	ANIME_ACT_END,							// I
};

//---------------------------------------------------------------------------

typedef struct {
	u16   act;								// 
	void  (*pFunc)(void);					// ߂̊֐
	u16   step;								// ߂̎sXebv

	u16   val;
	u16   waitNum;
	u16   waitCnt;
	u16   waitKey;
	char* pCur;
} ST_ANIME;


typedef struct {
	char* pStr;								// ߂̕
	void  (*pFunc)(void);					// ߂̊֐
} ST_ANIME_TABLE;

//---------------------------------------------------------------------------
EWRAM_CODE void AnimeInit(void);

EWRAM_CODE void AnimeSetDat(u16 no);
EWRAM_CODE void AnimeSetDat2(char* pDat);
EWRAM_CODE void AnimeSetFunc(void);

EWRAM_CODE void AnimeExec(void);
EWRAM_CODE void AnimeExecImage(void);
EWRAM_CODE void AnimeExecImage2(void);
EWRAM_CODE void AnimeExecImage3(void);
EWRAM_CODE void AnimeExecEffect(void);
EWRAM_CODE void AnimeExecUpdate(void);
EWRAM_CODE void AnimeExecText(void);
EWRAM_CODE void AnimeExecTextCls(void);
EWRAM_CODE void AnimeExecWait(void);
EWRAM_CODE void AnimeExecKeyWait(void);
EWRAM_CODE void AnimeExecBgm(void);
EWRAM_CODE void AnimeExecBgmWait(void);
EWRAM_CODE void AnimeExecSe(void);
EWRAM_CODE void AnimeExecSeWait(void);
EWRAM_CODE void AnimeExecSetVal(void);
EWRAM_CODE void AnimeExecSetPos(void);
EWRAM_CODE void AnimeExecInc(void);
EWRAM_CODE void AnimeExecJbe(void);
EWRAM_CODE void AnimeExecEnd(void);

EWRAM_CODE bool AnimeIsEnd(void);
EWRAM_CODE void AnimeCalcRemoveStrQuart(char* pDst, char* pSrc);


#ifdef __cplusplus
}
#endif
#endif
