#include "file.h"
#include "libmy/gbfs.h"


//---------------------------------------------------------------------------

const ST_FILE_SCO_TABLE FileScoTable[FILE_MAX_SCO_CNT] = {
	{ "#SYSTEM35"    },		// 0
	{ "STARTUP.SCO"  },		// 1
	{ "NVSETVAR.SCO" },
	{ "NVSYSTEM.SCO" },
	{ "NVSTR.SCO"    },
	{ "NVKEYIN.SCO"  },		// 5
	{ "NVGRP.SCO"    },
	{ "NVDEBUG.SCO"  },
	{ "NVFILE.SCO"   },
	{ "NVSOUND.SCO"  },
	{ "NVSYS.SCO"    },		// 10
	{ "NVSELECT.SCO" },
	{ "NVREC.SCO"    },
	{ "NVCALL.SCO"   },
	{ "NVGNUM.SCO"   },
	{ "NVCACHE.SCO"  },		// 15
	{ "NVCONFIG.SCO" },
	{ "XSPEC.SCO"    },
	{ "ADD.SCO"      },
	{ "HDDON.SCO"    },
	{ "MAIN.SCO"     },		// 20
	{ "MSUB.SCO"     },
	{ "0_OP.SCO"     },
	{ "1_1.SCO"    },
	{ "1_2.SCO"    },
	{ "1_3.SCO"    },		// 25
	{ "1_4.SCO"    },
	{ "1_5.SCO"    },
	{ "2_¸1.SCO"   },
	{ "2_¸2.SCO"   },
	{ "2_¸3.SCO"   },		// 30
	{ "2_¸4.SCO"   },
	{ "2_¸4A.SCO"  },
	{ "3_1.SCO"    },
	{ "3_T2.SCO"   },
	{ "3_T3.SCO"   },		// 35
	{ "3_S2.SCO"   },
	{ "3_S3T.SCO"  },
	{ "3_S3S.SCO"  },
	{ "4_1.SCO"   },
	{ "4_2.SCO"   },		// 40
	{ "4_3.SCO"   },
	{ "4_4.SCO"   },
	{ "4_5.SCO"   },
	{ "4_5A.SCO"  },
	{ "4_5B.SCO"  },		// 45
	{ "4_5B2.SCO" },
	{ "5_1.SCO"    },
	{ "5_2.SCO"    },
	{ "5_3.SCO"    },
	{ "5_4.SCO"    },		// 50
	{ "5_5.SCO"    },
	{ "5_6.SCO"    },
	{ "6_ϲ1.SCO"   },
	{ "6_ϲ2.SCO"   },
	{ "ENDING.SCO"   },		// 55
	{ "CGMODE.SCO"   },
	{ "MUSICMD.SCO"  },
	{ "HARLEM.SCO"   },
	{ "H.SCO"    },
	{ "H¸.SCO"   },		// 60
	{ "H.SCO"     },
	{ "H.SCO"    },
	{ "H޶.SCO"   },
	{ "Hź.SCO"     },
	{ "H¸.SCO"     },		// 65
	{ "H.SCO"     },
	{ "HެŲ.SCO"   },
	{ ".SCO"     },
};


//---------------------------------------------------------------------------
EWRAM_CODE void FileInit(void)
{
	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetSco(u16 num)
{
	_ASSERT(num < FILE_MAX_SCO_CNT);


	return (u8*)GbfsGetSafePointer(FileScoTable[num].pStr);
}
//---------------------------------------------------------------------------
EWRAM_CODE char* FileGetScoStr(u16 num)
{
	_ASSERT(num < FILE_MAX_SCO_CNT);


	return FileScoTable[num].pStr;
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetImg(u16 num)
{
	char buf[32];
	_Sprintf(buf, "G%03d.img", num);

	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetImgMask(u16 num)
{
	char buf[32];
	_Sprintf(buf, "G%03dM.img", num);

	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetMus(u16 num)
{
	char buf[32];
	_Sprintf(buf, "tr_%03d.8ad", num);

	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetSe(u16 num)
{
	char buf[32];
	_Sprintf(buf, "KUMOEF%02d.raw", num);

	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u32 FileGetSize(void)
{
	return GbfsGetFileSize();
}
