#include "img.h"
#include "libmy/mode3.h"
#include "libmy/fade.h"
#include "file.h"

//---------------------------------------------------------------------------
ST_IMG Img;


//---------------------------------------------------------------------------
EWRAM_CODE void ImgInit(void)
{
	_Memset(&Img, 0x00, sizeof(ST_IMG));
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgExec(void)
{
	if(Img.isDraw == FALSE)
	{
		return;
	}


	switch(Img.effectNo)
	{
	case IMG_EFFECT_03:
		ImgExecEffect03();
		break;

	case IMG_EFFECT_04:
		ImgExecEffect04();
		break;

	case IMG_EFFECT_06:
		ImgExecEffect06();
		break;

	case IMG_EFFECT_09:
	case IMG_EFFECT_05:			// p
	case IMG_EFFECT_22:			// p
	case IMG_EFFECT_23:			// p
	case IMG_EFFECT_32:			// p
		ImgExecEffect09();
		break;

	case IMG_EFFECT_12:
		ImgExecEffect12();
		break;

	case IMG_EFFECT_14:
		ImgExecEffect14();
		break;

	case IMG_EFFECT_15:
		ImgExecEffect15();
		break;

	case IMG_EFFECT_16:
		ImgExecEffect16();
		break;

	case IMG_EFFECT_17:
		ImgExecEffect17();
		break;

	case IMG_EFFECT_18:
		ImgExecEffect18();
		break;

	case IMG_EFFECT_20:
		ImgExecEffect20();
		break;

	default:
	case IMG_EFFECT_NORMAL:
	case IMG_EFFECT_64:			// p
		ImgExecEffectNormal();
		break;

	case IMG_EFFECT_OP:
		ImgExecEffectOp();
		break;

	case IMG_EFFECT_ED:
		ImgExecEffectEd();
		break;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgExecBuf(void)
{
	// LN^ԍꍇAwiɂāAޏԂtɂ܂
	if(Img.cgNo[1] != 0 && Img.cgNo[1] <= 32)
	{
		Mode3DrawBgClear();

		ImgDraw(Img.cgNo[0]);
		ImgDraw(Img.cgNo[1]);
	}
	else
	{
		ImgDraw(Img.cgNo[1]);
		ImgDraw(Img.cgNo[0]);
	}
}
//---------------------------------------------------------------------------
// PC΂㉺dˍ킹
EWRAM_CODE void ImgExecEffect03(void)
{
	switch(Img.step)
	{
	case 0:
		ImgExecBuf();
		Img.step++;
		break;

	default: ;
		u16 i;

		for(i=0; i<2; i++)
		{
			u16 y1 = (Img.step-1) * 2;
			u16 y2 = 160 - ((Img.step) * 2) + 1;

			Mode3Copy(0, y1, 239, y1);
			Mode3Copy(0, y2, 239, y2);

			Img.step++;
		}

		if(Img.step >= 80+1)
		{
			ImgSetDrawClear();
		}
		break;
	}
}
//---------------------------------------------------------------------------
// PC΂Edˍ킹
EWRAM_CODE void ImgExecEffect04(void)
{
	switch(Img.step)
	{
	case 0:
		ImgExecBuf();
		Img.step++;
		break;

	default: ;
		u16 i;

		for(i=0; i<2; i++)
		{
			u16 x1 = (Img.step-1) * 2;
			u16 x2 = 240 - ((Img.step) * 2) + 1;

			Mode3Copy(x1, 0, x1, 159);
			Mode3Copy(x2, 0, x2, 159);
			Img.step++;
		}

		if(Img.step >= 120+1)
		{
			ImgSetDrawClear();
		}
		break;
	}
}
//---------------------------------------------------------------------------
// UShbgubNO
EWRAM_CODE void ImgExecEffect06(void)
{
	switch(Img.step)
	{
	case 0:
		ImgExecBuf();
		Img.step++;
		break;

	default: ;
		u16 idx = Img.step - 1;
		u16 x, y;

		for(y=7; y<160; y+=16)
		{
			for(x=7; x<240; x+=16)
			{
				Mode3Copy(x-idx, y-idx, x+idx, y+idx);
			}
		}

		if(idx >= 7)
		{
			Mode3SetDraw(TRUE);
			ImgSetDrawClear();
		}
		Img.step++;
		break;
	}
}
//---------------------------------------------------------------------------
// 킶SSij
EWRAM_CODE void ImgExecEffect09(void)
{
	u16 cx[4] = { 0, 3, 0, 3 };
	u16 cy[4] = { 0, 3, 3, 0 };
	u16 x;
	u16 y;
	u16 idx = Img.step - 1;

	switch(Img.step)
	{
	case 0:
		ImgExecBuf();
		Img.step++;
		break;

	default:
		for(y=0; y<160; y+=8)
		{
			for(x=0; x<240; x+=8)
			{
				Mode3Copy(x+cx[idx], y+cy[idx], x+cx[idx]+4, y+cy[idx]+4);
			}
		}

		if(idx >= 3)
		{
			ImgSetDrawClear();
		}
		Img.step++;
		break;
	}
}
//---------------------------------------------------------------------------
// E
EWRAM_CODE void ImgExecEffect12(void)
{
	switch(Img.step)
	{
	case 0:
		ImgExecBuf();
		Img.step++;
		break;

	default: ; 
		u16 x = ((Img.step-1) * 8);
		Mode3Copy(x, 0, x+7, 159);
		Img.step++;

		if(Img.step >= 31)
		{
			ImgSetDrawClear();
		}
		break;
	}
}
//---------------------------------------------------------------------------
// と
EWRAM_CODE void ImgExecEffect14(void)
{
	switch(Img.step)
	{
	case 0:
		ImgExecBuf();
		Img.step++;
		break;

	default: ; 
		u16 y = ((Img.step-1) * 8);
		Mode3Copy(0, y, 239, y+7);
		Img.step++;

		if(Img.step >= 21)
		{
			ImgSetDrawClear();
		}
		break;
	}
}
//---------------------------------------------------------------------------
// 
EWRAM_CODE void ImgExecEffect15(void)
{
	switch(Img.step)
	{
	case 0:
		ImgExecBuf();
		Img.step++;
		break;

	default: ; 
		u16 y = ((Img.step-1) * 8);
		Mode3Copy(0, 159-y-7, 239, 159-y);
		Img.step++;

		if(Img.step >= 21)
		{
			ImgSetDrawClear();
		}
		break;
	}
}
//---------------------------------------------------------------------------
// cCL
EWRAM_CODE void ImgExecEffect16(void)
{
	switch(Img.step)
	{
	case 0:
		ImgExecBuf();
		Img.step++;
		break;

	default: ; 
		u16 x = 7 + ((Img.step-1) / 8) * 8;
		u16 w = Mod(Img.step-1, 8);
		u16 i;

		for(i=0; i<240; i+=16)
		{
			Mode3Copy(i+x+w, 0, i+x+w, 159);
			Mode3Copy(i+x-w, 0, i+x-w, 159);
		}
		Img.step++;

		if(Img.step >= 10)
		{
			ImgSetDrawClear();
		}
		break;
	}
}
//---------------------------------------------------------------------------
// CL
EWRAM_CODE void ImgExecEffect17(void)
{
	switch(Img.step)
	{
	case 0:
		ImgExecBuf();
		Img.step++;
		break;

	default: ; 
		u16 y = 7 + ((Img.step-1) / 8) * 8;
		u16 w = Mod(Img.step-1, 8);
		u16 i;

		for(i=0; i<160; i+=16)
		{
			Mode3Copy(0, i+y+w, 239, i+y+w);
			Mode3Copy(0, i+y-w, 239, i+y-w);
		}
		Img.step++;

		if(Img.step >= 10)
		{
			ImgSetDrawClear();
		}
		break;
	}
}
//---------------------------------------------------------------------------
// cCO
EWRAM_CODE void ImgExecEffect18(void)
{
	switch(Img.step)
	{
	case 0:
		ImgExecBuf();
		Img.step++;
		break;

	default: ; 
		u16 x = ((Img.step-1) / 8) * 8;
		u16 w = Mod(Img.step-1, 8);
		u16 i;

		for(i=0; i<240; i+=16)
		{
			Mode3Copy(i+x+w, 0, i+x+w, 159);
			Mode3Copy(i+x+15-w, 0, i+x+15-w, 159);
		}
		Img.step++;

		if(Img.step >= 9)
		{
			ImgSetDrawClear();
		}
		break;
	}
}
//---------------------------------------------------------------------------
// CO
EWRAM_CODE void ImgExecEffect20(void)
{
	switch(Img.step)
	{
	case 0:
		ImgExecBuf();
		Img.step++;
		break;

	default: ; 
		u16 y = ((Img.step-1) / 8) * 8;
		u16 w = Mod(Img.step-1, 8);
		u16 i;

		for(i=0; i<160; i+=16)
		{
			Mode3Copy(0, i+y+w, 239, i+y+w);
			Mode3Copy(0, i+y+15-w, 239, i+y+15-w);
		}
		Img.step++;

		if(Img.step >= 9)
		{
			ImgSetDrawClear();
		}
		break;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgExecEffectNormal(void)
{
	switch(Img.step)
	{
	case 0:
		ImgExecBuf();
		Img.step++;
		break;

	case 1:
		Mode3SetDraw(TRUE);
		ImgSetDrawClear();
		break;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgExecEffectOp(void)
{
	ST_IMG_HEADER* p1 = (ST_IMG_HEADER*)FileGetImg(100);	// wii{j
	ST_IMG_HEADER* p2 = (ST_IMG_HEADER*)FileGetImg(284);	// XN[

	if(Img.step >= p2->cy - 22*3)
	{
		ImgSetDrawClear();
		return;
	}

	Mode3DrawBg((u16*)(p1 + 1));
	Mode3DrawImgMask(0, 160-22*3-30, 240, 22*3, (u16*)(p2 + 1) + Img.step * 240, 0x0000);

	Mode3SetDraw(TRUE);
	Img.step++;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgExecEffectEd(void)
{
	if(Img.waitCnt != 0)
	{
		Img.waitCnt--;
		return;
	}
	Img.waitCnt = Img.wait;

	if(Img.step >= 60)
	{
		ImgSetDrawClear();
		return;
	}

	Mode3DrawBgClear();

	ST_IMG_HEADER* p = (ST_IMG_HEADER*)FileGetImg(267);
	Mode3DrawImgClip(69, 160 - Img.step, p->cx, p->cy, (u16*)(p + 1));

	Mode3SetDraw(TRUE);
	Img.step++;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgDraw(u16 no)
{
	if(no == 0)
	{
		Mode3DrawBgClear();
		return;
	}

	ST_IMG_HEADER* p = (ST_IMG_HEADER*)FileGetImg(no);

	// wiikj
	if(p->lzFlag == 1)
	{
		Mode3DrawBgLz77((u16*)(p + 1));
		return;
	}

	// wi
	if(p->cx == 240 && p->cy == 160)
	{
		Mode3DrawBg((u16*)(p + 1));
		return;
	}

	// wi
	if(p->cx == 240 && p->cy == 100)
	{
		Mode3DrawBgSmall((u16*)(p + 1));
		return;
	}

	// LN^
	ST_IMG_HEADER* pMask = (ST_IMG_HEADER*)FileGetImgMask(no);

	Mode3DrawBlend((u16*)(p + 1), (u16*)(pMask + 1), 240-p->cx, 160-p->cy, p->cx, p->cy);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgSetCg(u16 num, u16 no)
{
	_ASSERT(num < IMG_MAX_CG_REG_CNT);
	Img.cgNo[num] = no;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgSetEffect(u16 no, u16 wait)
{
	_ASSERT(no < IMG_EFFECT_NV_END);
	Img.effectNo = no;
	Img.wait = wait;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgSetEffect2(u16 no, u16 wait)
{
	_ASSERT(no < IMG_EFFECT_END);
	Img.effectNo = no;
	Img.wait = wait;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgSetDraw(void)
{
	Img.isDraw = TRUE;
	Img.step = 0;
	Img.waitCnt = Img.wait;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgSetDrawClear(void)
{
	Img.isDraw = FALSE;
	Img.effectNo = IMG_EFFECT_NORMAL;
}
//---------------------------------------------------------------------------
// Wߑł{`
EWRAM_CODE void ImgDirect(u16 no, u16 x, u16 y)
{
	ST_IMG_HEADER* p = (ST_IMG_HEADER*)FileGetImg(no);

	Mode3DrawImg(x, y, p->cx, p->cy, (u16*)(p + 1));
	Mode3SetDraw(TRUE);
}
//---------------------------------------------------------------------------
// fobO{`
EWRAM_CODE void ImgDirect2(u16 no)
{
	ImgDraw(no);
	Mode3SetDraw(TRUE);
}
//---------------------------------------------------------------------------
EWRAM_CODE bool ImgIsEnd(void)
{
	return (Img.isDraw == FALSE) ? TRUE : FALSE;
}
