#include "fade.h"


//---------------------------------------------------------------------------
ST_FADE Fade;


//---------------------------------------------------------------------------
EWRAM_CODE void FadeInit(void)
{
	_Memset(&Fade, 0x00, sizeof(ST_FADE));

	Fade.isEnd = TRUE;
	Fade.msg = 3;

	REG_BLDY = Fade.msg;
	REG_BLDCNT = (BLEND_MODE_DARK | BLEND_TOP_BG2);
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeExec(void)
{
	if(Fade.isEnd == TRUE)
	{
		return;
	}

	if(Fade.waitCnt != 0)
	{
		Fade.waitCnt--;
		return;
	}
	Fade.waitCnt = Fade.wait;


	Fade.cnt += Fade.change;
	REG_BLDY  = Fade.cnt;

	if(Fade.cnt == Fade.end)
	{
		Fade.isEnd = TRUE;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeSetDefault(u16 mode, u16 wait)
{
	Fade.isEnd   = FALSE;
	Fade.cnt     = 0;
	Fade.end     = 0;
	Fade.change  = 0;
	Fade.wait    = wait;
	Fade.waitCnt = wait;

	REG_BLDCNT = (mode | BLEND_TOP_BG2);
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeSetDrakIn(u16 wait)
{
	FadeSetDefault(BLEND_MODE_DARK, wait);

	Fade.cnt    = 0;
	Fade.end    = 15;
	Fade.change = 1;
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeSetDrakOut(u16 wait)
{
	FadeSetDefault(BLEND_MODE_DARK, wait);

	Fade.cnt    = 15;
	Fade.end    = 0;
	Fade.change = -1;
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeSetLightIn(u16 wait)
{
	FadeSetDefault(BLEND_MODE_LIGHT, wait);

	Fade.cnt    = 0;
	Fade.end    = 15;
	Fade.change = 1;
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeSetLightOut(u16 wait)
{
	FadeSetDefault(BLEND_MODE_LIGHT, wait);

	Fade.cnt    = 15;
	Fade.end    = 0;
	Fade.change = -1;
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeDirect(u16 num)
{
	Fade.msg = num;
	REG_BLDY = num;
}
//---------------------------------------------------------------------------
EWRAM_CODE u16 FadeGetMsgFade(void)
{
	return Fade.msg;
}
//---------------------------------------------------------------------------
EWRAM_CODE bool FadeIsEnd(void)
{
	return Fade.isEnd;
}
