#ifndef __FADE_H__
#define __FADE_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "../libgba/gba.h"


//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
typedef struct {
	bool isEnd;
	s16  cnt;
	s16  end;
	s16  change;
	s16  wait;
	s16  waitCnt;

	u16  msg;
} ST_FADE;


//---------------------------------------------------------------------------
EWRAM_CODE void FadeInit(void);
EWRAM_CODE void FadeExec(void);

EWRAM_CODE void FadeSetDefault(u16 mode, u16 wait);
EWRAM_CODE void FadeSetDrakIn(u16 wait);
EWRAM_CODE void FadeSetDrakOut(u16 wait);
EWRAM_CODE void FadeSetLightIn(u16 wait);
EWRAM_CODE void FadeSetLightOut(u16 wait);
EWRAM_CODE u16  FadeGetMsgFade(void);


EWRAM_CODE void FadeDirect(u16 num);
EWRAM_CODE bool FadeIsEnd(void);


#ifdef __cplusplus
}
#endif
#endif
