#ifndef __MODE3_H__
#define __MODE3_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "../libgba/gba.h"

//---------------------------------------------------------------------------
#define MODE3_MAX_BUF_SIZE			(SCREEN_WIDTH * SCREEN_HEIGHT * 2)


//---------------------------------------------------------------------------
typedef struct {
	bool isDraw;
	u16  buf[MODE3_MAX_BUF_SIZE/2] ALIGN(4);

} ST_MODE3;


//---------------------------------------------------------------------------
EWRAM_CODE void Mode3Init(void);
IWRAM_CODE void Mode3Exec(void);

IWRAM_CODE void Mode3DrawBg(u16* pBuf);
IWRAM_CODE void Mode3DrawBgSmall(u16* pBuf);
IWRAM_CODE void Mode3DrawBgLz77(u16* pBuf);
IWRAM_CODE void Mode3DrawBgFill(u16 col);
IWRAM_CODE void Mode3DrawBgClear(void);
IWRAM_CODE void Mode3DrawBlend(u16* pImg, u16* pMask, u16 sx, u16 sy, u16 cx, u16 cy);
IWRAM_CODE void Mode3DrawImg(u16 sx, u16 sy, u16 cx, u16 cy, u16* img);
IWRAM_CODE void Mode3DrawImgMask(u16 sx, u16 sy, u16 cx, u16 cy, u16* img, u16 mask);
IWRAM_CODE void Mode3DrawImgClip(s16 sx, s16 sy, s16 cx, s16 cy, u16* img);
IWRAM_CODE void Mode3Copy(u16 sx, u16 sy, u16 cx, u16 cy);

EWRAM_CODE void Mode3SetDraw(bool isDraw);

#ifdef __cplusplus
}
#endif
#endif
