#include "manage.h"
#include "img.h"
#include "text.h"
#include "anime.h"
#include "history.h"
#include "menu.h"
#include "nv.h"
#include "bgm.h"
#include "se.h"
#include "file.h"
#include "siori.h"


//---------------------------------------------------------------------------
ST_MANAGE Manage;


//---------------------------------------------------------------------------
EWRAM_CODE void ManageInit(void)
{
	_Memset(&Manage, 0x00, sizeof(ST_MANAGE));

	Manage.act = MANAGE_ACT_INIT;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageExec(void)
{
	switch(Manage.act)
	{
	case MANAGE_ACT_INIT:
		ManageExecInit();
		break;

	case MANAGE_ACT_TITLE:
		ManageExecTitle();
		break;

	case MANAGE_ACT_SCRIPT:
		ManageExecScript();
		break;

	default:
		SystemError("[Err] ManageExec Manage.act=%d\n", Manage.act);
		break;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageInitTitle(void)
{
	ImgDirect(267, 134, 132);
	MenuSetTitle();
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageExecInit(void)
{
	FileInit();

	BgmInit();
	SeInit();

	ImgInit();
	TextInit();

	AnimeInit();
	HistoryInit();
	MenuInit();
	NvInit();

	SioriInit();

	ManageInitTitle();
	Manage.act = MANAGE_ACT_TITLE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageExecTitle(void)
{
	MenuExec();

	if(MenuIsEnd() == TRUE)
	{
		Manage.act = MANAGE_ACT_SCRIPT;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageExecScript(void)
{
	ImgExec();
	TextExec();

	AnimeExec();
	HistoryExec();
	MenuExec();

	NvExec();

	if(NvIsEnd() == TRUE && AnimeIsEnd() == TRUE && ImgIsEnd() == TRUE && TextIsEnd() == TRUE)
	{
		ManageInitTitle();
		Manage.act = MANAGE_ACT_TITLE;
	}
}
