#ifndef __NV_H__
#define __NV_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define NV_MAX_VAR_CNT				260
#define NV_MAX_CALC_CNT				16
#define NV_MAX_CALL_CNT				16
#define NV_MAX_MSG_SIZE				256
#define NV_MAX_SEL_CNT				10
#define NV_MAX_SEL_BUF_SIZE			32
#define NV_MAX_CHR_TABLE_CNT		5


enum {
	NV_ACT_PARSE = 0x01,
	NV_ACT_KEY,
	NV_ACT_SELECT,
	NV_ACT_END_READY,
	NV_ACT_END,
};

//---------------------------------------------------------------------------

typedef struct {
	// 
	u16   act;
	u16   actStep;
	s16   waitCnt;
	bool  isLoop;
	bool  isSkip;					// bZ[WGtFNgXLbv
	bool  isTextClear1st;
	bool  isSeWait;

	// Q[֌W
	u8*   pHead;					// wb_ʒu
	u8*   pCur;						// J[\
	u16   var[NV_MAX_VAR_CNT];		// tO

	// bZ[W
	s16   msgCnt;
	u8    msg[NV_MAX_MSG_SIZE] ALIGN(4);

	// R[e[u
	s16   callCnt;
	u16   callNo[NV_MAX_CALL_CNT];
	u32   callAdr[NV_MAX_CALL_CNT];

	// t|[hvZp
	s16   calcCnt;
	u16   calcTbl[NV_MAX_CALC_CNT];

	// I
	s16   sel;
	s16   selCnt;					// o^
	s16   selRegCnt;				// o^CfbNXvZp
	u16   selNum[NV_MAX_SEL_CNT];
	u16   selBuf[NV_MAX_SEL_CNT][NV_MAX_SEL_BUF_SIZE];

	// XNvgf[^
	char* pStr;						// t@Ciscoj
	u32   datAdr;					// ViIf[^̑΃AhX
	u32   size;						// t@CTCY
	u16   no;						// f[^ԍ

} ST_NV;


typedef struct {
	char sig[4];					// VOl` "S351"
	u32  datAdr;					// ViIf[^̑΃AhX
	u32  size;						// t@CTCY
	u32  dataNo;					// f[^ԍ
	u16  advLen;					// RpCÕt@C̒
	char advName;					// RpCÕt@CiadvLenj
} __PACKED ST_NV_SCO_HEADER;


//---------------------------------------------------------------------------
EWRAM_CODE void NvInit(void);

EWRAM_CODE void NvExec(void);
EWRAM_CODE void NvExecKey(void);
EWRAM_CODE bool NvExecKeySub(void);
EWRAM_CODE void NvExecSelect(void);
EWRAM_CODE void NvExecEndReady(void);

EWRAM_CODE void NvSetAct(u16 act);
EWRAM_CODE void NvSetSco(u16 no, u16 adr);
EWRAM_CODE void NvSetSkip(bool is);
EWRAM_CODE void NvSetCapter(u16 no);
EWRAM_CODE void NvSetChrFlag(u16 num, u16 no);
EWRAM_CODE u16  NvGetChrFlag(u16 num);

EWRAM_CODE bool NvIsEnd(void);


#ifdef __cplusplus
}
#endif
#endif

