/*
 * pms64k.c  PMS 6 Ÿ
 *
 * Copyright (C) 1997-1998 Masaki Chikama (Wren) <chikama@kasumi.ipl.mech.nagoya-u.ac.jp>
 *               1998-                           <masaki-c@is.aist-nara.ac.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *          0.00 97/11/06 
 *          0.01 97/11/13 إå֤ѹ
 *          0.02 98/02/26 ǥХåλ
 * @version 0.03 98/07/27 סƩŸޤäƤ
 *
*/
/* $Id: pms64k.c,v 1.1.1.1 1999/04/17 13:14:15 chikama Exp $ */

#include <stdlib.h>
#include "portab.h"
#include "cg.h"

/* define in pms256.c */
extern void pms256_expand_8bpp(const BYTE *b, BYTE *pic, int ptr);
extern void pms256_getHdr(const BYTE *data, Pms_header *pms);

static Pms_header pms64k;

static void
pms64k_expand_16bpp(const BYTE *b, int ptr, WORD *pic, BYTE *shade) {
	int c0,c1,pc0,pc1;
	int x,y,i,l,loc;
	int scanline = pms64k.pmsXW;
	boolean hasAlpha = (pms64k.pmsPp != 0) ? true : false;
	BYTE *_b = (BYTE *)b;
	
	b += ptr; 
	for (y = 0; y < pms64k.pmsYW; y++) {
		for (x = 0; x < pms64k.pmsXW;) {
			loc = y * scanline + x;
			c0 = *b++;
			if (c0 <= 0xf7) {
				c1 = *b++; x++;
				*(pic + loc) = c0 | (c1 << 8);
			} else if (c0 == 0xff) {
				l = (*b) + 2; x+=l; b++;
				for (i = 0; i < l; i++) {
					*(pic + loc + i) = *(pic + loc + i - scanline);
				}
			} else if (c0 == 0xfe) {
				l = (*b) + 2; x+=l; b++;
				for (i = 0; i < l; i++) {
					*(pic + loc + i) = *(pic + loc + i - scanline * 2);
				}
			} else if (c0 == 0xfd) {
				l = (*b) + 3; x+=l; b++;
				c0 = *b++; c1 = *b++;
				pc0 = c0 | (c1 << 8);
				for (i = 0; i < l; i++) {
					*(pic + loc + i) = pc0;
				}
			} else if (c0 == 0xfc) {
				l = ((*b) + 2) * 2; x+=l; b++;
				c0 = *b++; c1 = *b++; pc0 = c0 | (c1 << 8);
				c0 = *b++; c1 = *b++; pc1 = c0 | (c1 << 8);
				for (i = 0; i < l; i+=2) {
					*(pic + loc + i    ) = pc0;
					*(pic + loc + i + 1) = pc1;
				}
			} else if (c0 == 0xfb) {
				x++;
				*(pic + loc) = *(pic + loc - scanline - 1);
			} else if (c0 == 0xfa) {
				x++;
				*(pic + loc) = *(pic + loc - scanline + 1);
			} else if (c0 == 0xf9) {
				l = (*b) + 1; x+=l; b++;
				c0 = *b++; c1 = *b++;
				pc0 = ((c0 & 0xe0) << 8) + ((c0 & 0x18) << 6) + ((c0 & 0x07) << 2);
				pc1 = ((c1 & 0xc0) << 5) + ((c1 & 0x3c) << 3) + (c1 & 0x03);
				*(pic + loc) = pc0 + pc1;
				for (i = 1; i < l; i++) {
					c1 = *b++;
					pc1 = ((c1 & 0xc0) << 5) + ((c1 & 0x3c) << 3) + (c1 & 0x03);
					*(pic + loc + i) = pc0 | pc1;
				}
			} else {
				c0 = *b++; c1 = *b++; x++;
				*(pic + loc) = c0 | (c1 << 8);
			}
		}
	}
	/* expand shade pixcel */
	if (hasAlpha) {
		pms256_expand_8bpp(_b, shade, pms64k.pmsPp);
	}
}

extern boolean
Pms64k_checkFmt(const BYTE *data) {
	if (data[0] != 0x50 || data[1] != 0x4d)   { return false; }
	pms256_getHdr(data, &pms64k);
	if (pms64k.pmsBpp != 16)                  { return false; }
	if (pms64k.pmsX0 < 0 || pms64k.pmsY0 < 0) { return false; }
	return true;
}

extern void
Pms64k_expandCg(const BYTE *data,WORD *pic, boolean *hasAlpha, BYTE *shade) {
	pms64k_expand_16bpp(data, pms64k.pmsDp, pic, shade);
	*hasAlpha =  (pms64k.pmsPp != 0) ? TRUE : FALSE;
}

extern Pms_header *
Pms64k_getCgInfo() {
	return &pms64k;
}

extern void
Pms64k_getInitLoc(MyPoint *p) {
	p->x = pms64k.pmsX0;
	p->y = pms64k.pmsY0;
}

extern void
Pms64k_getSize(MyDimension *d) {
	d->width  = pms64k.pmsXW;
	d->height = pms64k.pmsYW;
}
